Subject: Re: [PATCH 2/2] hex: drop sha1_to_hex()

From: SZEDER Gábor <[email-masked]>
Date: Tue, 12 Nov 2019 12:44:58 +0100

On Tue, Nov 12, 2019 at 05:57:59AM -0500, Jeff King wrote:
> On Tue, Nov 12, 2019 at 01:13:58PM +0900, Junio C Hamano wrote:
> 
> > >> We can't use oid_to_hex() because we don't have a 'struct object_id'
> > >> in the first place, as sha1dc only ever deals with 20 unsigned chars.
> > >
> > > Ah, you're right. I admit I am still getting up to speed on all of the
> > > new hash-agnostic versions of the various functions.
> > 
> > Thanks.  I've amended this one and the range diff since the pushout
> > yesterday looks like this.
> 
> Thanks. This first hunk is what I would have done:
> 
> > 1:  8a030f1796 ! 1:  02d21d4117 hex: drop sha1_to_hex()
> >     @@ Commit message
> >          hex: drop sha1_to_hex()
> >      
> >          There's only a single caller left of sha1_to_hex(), since everybody now
> >     -    uses oid_to_hex() instead. This case is in the sha1dc wrapper, where we
> >     +    uses hash_to_hex() instead. This case is in the sha1dc wrapper, where we
> >          print a hex sha1 when we find a collision. This one will always be sha1,
> >     -    regardless of the current hash algorithm, so we can't use oid_to_hex()
> >     +    regardless of the current hash algorithm, so we can't use hash_to_hex()
> >          here. In practice we'd probably not be running sha1 at all if it isn't
> >          the current algorithm, but it's possible we might still occasionally
> >          need to compute a sha1 in a post-sha256 world.
> 
> This second one is OK, but not entirely necessary:
> 
> >     @@ cache.h: int hex_to_bytes(unsigned char *binary, const char *hex, size_t len);
> >        * buffers, making it safe to make multiple calls for a single statement, like:
> >        *
> >      - *   printf("%s -> %s", sha1_to_hex(one), sha1_to_hex(two));
> >     -+ *   printf("%s -> %s", oid_to_hex(one), oid_to_hex(two));
> >     ++ *   printf("%s -> %s", hash_to_hex(one), hash_to_hex(two));
> >        */
> >       char *hash_to_hex_algop_r(char *buffer, const unsigned char *hash, const struct git_hash_algo *);
> >       char *oid_to_hex_r(char *out, const struct object_id *oid);
> 
> This one-liner leaves the types of "one" and "two" unspecified. :) So
> it's not wrong to use hash_to_hex(), but maybe it's better to be pushing
> people towards oid_to_hex() as their first choice? It probably doesn't
> matter too much either way.

Yeah, most (over 96%) of the hashes that we print are actually object
ids, so oid_to_hex() is the right function to use most of the time.

And because of this the updated "since everybody uses hash_to_hex()"
in the first hunk sounds a bit wrong, because barely anybody actually
uses hash_to_hex().